/*
 * Example program using the HomeEasy class.
 * A Disturbing echo repeater
 * 2015-12-10 Ben Smeets
 */

#include "HomeEasy.h"

HomeEasy homeEasy;

class relaydata {
 public:
  unsigned long sender;
  unsigned int recipient;
  bool group;
  bool command;
  bool loaded;
};

// we store here the received data
relaydata data;

/**
 * Set up the serial interface and the HomeEasy class.
 */
void setup()
{
	Serial.begin(9600);
	
	homeEasy = HomeEasy();
	
        data.loaded = false;
        
	homeEasy.registerAdvancedProtocolHandler(printResult);
	
	homeEasy.init();
}


  
/**
 * No processing is required in the loop for receiving.
 */


/**
 * We receive a command and then send it again out 4 seconds later but with on/off toggled
   Quite disturbing
 */

void loop()
{
  //delay(5000);
/*  data.sender = 52637304;
  data.recipient =11;
  data.command = false;
  data.group = true;
  data.loaded = true;
*/
  if (data.loaded) {  // we enter here if we received someting
    delay(4000);
    data.command = (data.command) ? false: true;
    homeEasy.sendAdvancedProtocolMessage(data.sender, data.recipient, data.command, data.group);
    data.loaded = false;
  }
}


/**
 * Print the details of the advanced protocol message.
 */
void printResult(unsigned long sender, unsigned int recipient, bool on, bool group)
{
        data.sender = sender;
        data.recipient = recipient;
        data.command = on;
        data.group= group;
        data.loaded = true;
        
	interrupts();
        Serial.print("message");
	//PrintBinLong(sender);
        Serial.print("\n");
	Serial.print("sender ");
	Serial.println(sender);
	
	Serial.print("recipient ");
	Serial.println(recipient);
	
	Serial.print("on ");
	Serial.println(on);
	
	Serial.print("group ");
	Serial.println(group);
	
	Serial.println();
        noInterrupts();
}

void PrintBinLong(unsigned long data){
  int i;
  unsigned long bitt;
  for (i=0;i<32;i++){
    bitt = 0x1 & (data >> (31-i));
    Serial.print(bitt,BIN);
  }
}
